#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! File Name:   app_dll.tpl
#! Purpose:     Access files in other DLL's dictionaries
#! Author:      Roberto Artigas Jr
#! Changes:
#! 1999.08.10   Roberto Artigas Jr
#!      Added 'SET','NEXT','PREV' for access and code associated.
#! 1999.11.12   Roberto Artigas Jr
#!      Begin Adding RECORD order definitions and access.
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#TEMPLATE(zAppMultiDLL, '2000.12.27: Multi-DLL Application templates'),FAMILY('ABC')
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#UTILITY (GenerateRecords, '2000.12.30: Generate Records'), WIZARD
#!--------------------------------------------------------------------
#PREPARE
#DECLARE (%RecOps), MULTI
#ADD(%RecOps,'GET')
#ADD(%RecOps,'PUT')
#ADD(%RecOps,'SET')
#ADD(%RecOps,'NEXT')
#ADD(%RecOps,'PREV')
#ENDPREPARE
#!--------------------------------------------------------------------
#SHEET
  #TAB ('Generate Records')
    #BOXED('')
      #DISPLAY('Solution created by: Roberto Artigas Jr.')
      #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
      #DISPLAY('Wizard created by: Roberto Artigas Jr.')
      #DISPLAY('')
      #DISPLAY('This is a part of a multi-dictionary application solution.')
      #DISPLAY('Each dictionary being in it''s own DLL.')
      #DISPLAY('')
      #DISPLAY('This part creates:')
      #DISPLAY('1) Record definitions to access files in another DLL.')
      #DISPLAY('')
      #DISPLAY('This wizard will generate group definitions of the contents of your current dictionary.')
      #DISPLAY('To specify how you want generation, click on the Next button.')
    #ENDBOXED
  #ENDTAB
  #TAB ('Generate Records Wizard - Generated Files'), FINISH(1)
    #BOXED('')
      #DISPLAY('You can generate on each file in your dictionary, or you can select individual files to generate.')
      #DISPLAY('')
      #PROMPT('Generate all files in my dictionary.', CHECK), %DictionaryReportUseAllFiles, DEFAULT(1), AT(10)
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
    #ENDBOXED
  #ENDTAB
  #TAB ('Generated Records Wizard - Select Files To Generate'), WHERE(~%DictionaryReportUseAllFiles), FINISH(1)
    #BOXED('')
      #DISPLAY('')
      #PROMPT('File Selection', FROM (%File)), %DictionaryReportFileSelection, INLINE, SELECTION('File Selection')
      #DISPLAY('')
    #ENDBOXED
  #ENDTAB
  #TAB ('Generated Records Wizard - Finally...')
    #BOXED('')
      #DISPLAY('This concludes the dictionary Group Generate wizard.')
      #DISPLAY('')
      #DISPLAY('Click on the Finish button to generate Groups.')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
      #DISPLAY('')
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#COMMENT(45)
#DECLARE (%ReportedFiles),UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%ValueConstruct)
#DECLARE (%TheKeyId)
#DECLARE (%TheKeyNo,LONG)
#IF (%DictionaryReportUseAllFiles)
  #FOR (%File)
    #ADD (%ReportedFiles, %File)
  #ENDFOR
#ELSE
  #FOR (%DictionaryReportFileSelection)
    #ADD (%ReportedFiles, %DictionaryReportFileSelection)
  #ENDFOR
#ENDIF
#DECLARE (%OutputFile)
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
  #SET (%OutputFile,%FILE&'.GRP')
  #MESSAGE('File Group Definition: ' & %OutputFile, 2)
  #CREATE (%OutputFile)
!BOF
!
! File:         %OutputFile
! Purpose:      Generated File Records as Groups
! Author:       Roberto Artigas Jr
! Narative:     This template is used to pass records structures
!               back and forth between DLL's when the files
!               are not shared. Since file definitions are not
!               available, data has to be passed in areas.
!
  #IF (%FileType = 'ALIAS')
! Name:         %File(An alias for %AliasFile)
  #ELSE
! Name:         %File
  #ENDIF
! Prefix:       %FilePrefix
  #IF (%FileDescription)
! Description:  %FileDescription
  #ENDIF
  #IF (%FileName)
! Filename:     %FileName
  #ENDIF
!
!-Keys-
  #SUSPEND
    #FOR (%Key)
! %[25]KeyID %|
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
        #IF (INSTANCE(%KeyField) = 1)
%FieldID(%KeyFieldSequence)
        #ELSE
!%[27]Null%FieldID(%KeyFieldSequence)
        #ENDIF
      #ENDFOR
    #ENDFOR
  #RESUME
!-Keys Equates-
  #SUSPEND
    #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
%[27]TheKeyId EQUATE(0)
    #SET(%TheKeyNo,1)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
          #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
%[27]TheKeyId EQUATE(%TheKeyNo)
          #SET(%TheKeyNo,%TheKeyNo+1)
      #ENDFOR
    #ENDFOR
  #RESUME
!-Keys-
  #SUSPEND
    #SET(%TheKeyNo,0)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
        #IF (INSTANCE(%KeyField) = 1)
          #!SET(%TheKeyId,SUB(%KeyID,1,INSTRING('_',%KeyID,1,1)-1))
          #SET(%TheKeyId,'Key'&%TheKeyNo)
%FilePrefix:mKey:%KeyID GROUP,BINDABLE,TYPE !,PRE(m%FilePrefix:%TheKeyId)
%FieldStruct #<! %FieldDescription
          #SET(%TheKeyNo,%TheKeyNo+1)
        #ELSE
%FieldStruct #<! %FieldDescription
        #ENDIF
      #ENDFOR
  END
    #ENDFOR
  #RESUME
!-Record Equates-
  #SUSPEND
    #SET(%TheKeyNo,1)
    #FOR (%RecOps)
      #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%RecOps))
%[27]TheKeyId EQUATE(%TheKeyNo)
      #SET(%TheKeyNo,%TheKeyNo+1)
    #ENDFOR
  #RESUME
!-Record-
  #SUSPEND
%FilePrefix:mRec GROUP,BINDABLE,TYPE !,PRE(m%FilePrefix)
    #FOR (%Field)
%FieldStruct #<! %FieldDescription
    #ENDFOR
  END
  #RESUME
!
!-Communication Area-
%FilePrefix:mCom GROUP,BINDABLE,TYPE !,PRE(c%FilePrefix)
Action LONG #<! What To Do
Result LONG #<! What The Result Was
KeyNum LONG #<! Key Number To Use
KeyDat STRING(255) #<! Key Holding Area
  #SUSPEND
    #SET(%TheKeyNo,0)
    #FOR (%Key)
      #FOR (%KeyField)
        #FIX (%Field, %KeyField)
          #SET(%TheKeyId,'Key'&%TheKeyNo)
%KeyID LIKE(%FilePrefix:mKey:%KeyID),OVER(KeyDat)
          #SET(%TheKeyNo,%TheKeyNo+1)
      #ENDFOR
    #ENDFOR
  #RESUME
ErrMsg STRING(255) #<! Error Message
  END
!
!EOF
#CLOSE (%OutputFile)
#ENDFOR
#!---------------------------------------------------------------------
#GROUP(%GenerateRecordsEnd)
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#EXTENSION(GenerateModules,'2000.12.27: Generate Modules'),APPLICATION,MULTI
#!---------------------------------------------------------------------
#PREPARE
#ENDPREPARE
#!---------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A driver function to access an internal file.')
  #ENDBOXED
#ENDTAB
#TAB('Generate Module')
#ENDTAB
  #BOXED('')
    #PROMPT('File Name:',FROM(%File)),%modFile,REQ,DEFAULT('')
  #ENDBOXED
#ENDSHEET
#!---------------------------------------------------------------------
#COMMENT(45)
#!---------------------------------------------------------------------
#ATSTART
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#!
#DECLARE(%RecOps), MULTI
#ADD(%RecOps,'GET')
#ADD(%RecOps,'PUT')
#ADD(%RecOps,'SET')
#ADD(%RecOps,'NEXT')
#ADD(%RecOps,'PREV')
#!
#DECLARE (%TheKeyId)
#DECLARE (%TheKeyNo,LONG)
#!
#DECLARE (%RaFileName, STRING)
#DECLARE (%RaClipName, STRING)
#DECLARE (%RaWorkName, STRING)
#!
#DECLARE(%ReportedFiles),UNIQUE
#DECLARE(%LocB,LONG)
#DECLARE(%LocE,LONG)
#!
#FOR (%File)
  #IF(%File=%modFile)
    #ADD (%ReportedFiles, %File)
  #END
#ENDFOR
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
  #SET (%RaClipName, %FilePrefix)
  #SET (%RaFileName, %RaClipName & '.clw')
  #SET (%RaWorkName, %RaClipName & '.$$$')
  #PROJECT (%RaFileName)
  #CREATE (%RaWorkName)
!BOF
!---------------------------------------------------------------------
!---------------------------------------------------------------------
! File:         %RaFileName
! Purpose:      File Access From Other DLL's and Exe's
!---------------------------------------------------------------------
  MEMBER('%Application.clw')

  INCLUDE('%File.GRP') #<! Memory Definition

!
! Procedure:    Driver_%FilePrefix
! Purpose:      Allow other DLL's and EXE's to my files
! Author:       Roberto Artigas Jr
! ASSUMES:      Files are already declared
!
Driver_%FilePrefix PROCEDURE(%FilePrefix_mCom, %FilePrefix_mRec)
  CODE
  LOCK(%File) #<! Wait until locked

  OPEN(%File)
  IF ERROR() THEN
    %FilePrefix_mCom.Result = ERRORCODE()
    %FilePrefix_mCom.ErrMsg = ERROR()
    RETURN
  END   

  CASE(%FilePrefix_mCom.Action)
  #SUSPEND
    #FOR (%RecOps)
      #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%RecOps))

    OF %TheKeyId
      #CASE(%RecOps)
      #OF('GET')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          GET(%File,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          IF (%FilePrefix:%FieldId <> %FilePrefix_mCom.%KeyID.%FieldId) THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #ENDFOR
        #ENDFOR
      END
      %FilePrefix_mRec :=: %FilePrefix:Record
      %FilePrefix_mCom.Result = ERRORCODE()
      %FilePrefix_mCom.ErrMsg = ERROR()
      #OF('PUT')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          GET(%File,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          IF (%FilePrefix:%FieldId <> %FilePrefix_mCom.%KeyID.%FieldId) THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #ENDFOR
        #ENDFOR
      END
      %FilePrefix:Record :=: %FilePrefix_mRec
      PUT(%File)
      %FilePrefix_mCom.Result = ERRORCODE()
      %FilePrefix_mCom.ErrMsg = ERROR()
      #OF('SET')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #ENDFOR
      END
      #OF('NEXT')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          NEXT(%File)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          %FilePrefix_mCom.%KeyID.%FieldId = %FilePrefix:%FieldId
          #ENDFOR
        #ENDFOR
      END
      #OF('PREV')
      CASE(%FilePrefix_mCom.KeyNum)
        #SET(%TheKeyNo,0)
        #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_RECORD')
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
        #FOR (%Key)
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
            #IF (INSTANCE(%KeyField) = 1)
              #SET(%TheKeyId,'EQU_'&UPPER(%FilePrefix)&'_'&UPPER(%KeyID))
        OF %TheKeyId
          CLEAR(%FilePrefix:Record)
              #SET(%TheKeyId,'Key'&%TheKeyNo)
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
              #SET(%TheKeyNo,%TheKeyNo+1)
            #ELSE
          %FilePrefix:%FieldId = %FilePrefix_mCom.%KeyID.%FieldId
            #ENDIF
          #ENDFOR
          SET(%FilePrefix:%KeyId,%FilePrefix:%KeyID)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END   
          PREVIOUS(%File)
          IF ERROR() THEN
            %FilePrefix_mCom.Result = ERRORCODE()
            %FilePrefix_mCom.ErrMsg = ERROR()
            CLEAR(%FilePrefix_mRec)
            RETURN
          END
          #FOR (%KeyField)
            #FIX (%Field, %KeyField)
          %FilePrefix_mCom.%KeyID.%FieldId = %FilePrefix:%FieldId
          #ENDFOR
        #ENDFOR
      END
      #ENDCASE
    #ENDFOR
  #RESUME
  END

  CLOSE(%File)
  IF ERROR() THEN
    %FilePrefix_mCom.Result = ERRORCODE()
    %FilePrefix_mCom.ErrMsg = ERROR()
  END   

  UNLOCK(%File) #<! Done with file
  RETURN

!---------------------------------------------------------------------
!---------------------------------------------------------------------
!EOF
#CLOSE (%RaWorkName)
#REPLACE (%RaFileName, %RaWorkName)
#REMOVE (%RaWorkName)
#ENDFOR
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%AfterGlobalIncludes)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%GlobalMap)
MODULE('%RaFileName')
#INDENT(-5)
#FOR (%ReportedFiles)
  #FIX (%File, %ReportedFiles)
Driver_%FilePrefix PROCEDURE(*%FilePrefix:mCom, *%FilePrefix:mRec)
#ENDFOR
#INDENT(5)
END
#ENDAT
#!---------------------------------------------------------------------
#AT(%GlobalData)
#ENDAT
#!---------------------------------------------------------------------
#GROUP(%GenerateModulesEnd)
#!---------------------------------------------------------------------

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#! 2000.02.21 - Roberto Artigas Jr
#EXTENSION(NoABCExports,'2000.02.21: Suppress GLOBAL Data and Exports (ABC)'),APPLICATION
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Craig Ransom')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part:')
    #DISPLAY('1) Suppresses all Clarion global data and global classes.')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!---------------------------------------------------------------------
#ATSTART
  #DECLARE(%HoldGlobalExternal)
#ENDAT
#AT(%BeginningExports)
  #SET(%HoldGlobalExternal,%GlobalExternal)
  #SET(%GlobalExternal,%True)
#ENDAT
#AT(%DLLExportList)
  #SET(%GlobalExternal,%HoldGlobalExternal)
#ENDAT
#!---------------------------------------------------------------------
#GROUP(%NoABCExportsEnd)
#!---------------------------------------------------------------------

#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#!--------------------------------------------------------------------
#EXTENSION(PrototypeExporter,'2000.12.30: Prototype Exporter'),APPLICATION
#!--------------------------------------------------------------------
#! Notes:       Will NOT Handle the NAME('') after the return type
#! Created By:  Roberto Artigas Jr
#!--------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A prototype (STD) file with all the exported routines.')
  #ENDBOXED
#ENDTAB
#TAB('Parameters')
  #BOXED('Prototype Exporter')
    #PROMPT('Include Filename:',@S13), %IncludeFilename, REQ, DEFAULT(UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)) & '.STD')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!----------
#AT(%CustomGlobalDeclarations),WHERE(%ProgramExtension='DLL')
  #DECLARE(%TheOOPConstruct)
  #DECLARE(%TheBuildInclude)
  #SET(%TheBuildInclude,UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)) & '.$$$')
  #CREATE(%TheBuildInclude)
!BOF
!
! File:         %IncludeFileName
! Purpose:      Include Of DLL Procedures
! Author:       Roberto Artigas Jr
!
  #FOR(%Procedure),WHERE(%ProcedureExported)
    #INSERT(%MakeDeclr(ABC), 28, %TheOOPConstruct, %Procedure, %ProcedureType & %Prototype & ',DLL')
#!    #IF(%ProcedureDescription)
#!      #INSERT(%MakeDeclr(ABC), 55, %TheOOPConstruct, %OOPConstruct, '! ' & ProcedureDescription)
#!    #ENDIF
%TheOOPConstruct
  #ENDFOR
!
!EOF
  #CLOSE(%TheBuildInclude)
  #REPLACE(%IncludeFilename, %TheBuildInclude)
  #REMOVE(%TheBuildInclude)
#ENDAT
#!---------------------------------------------------------------------
#GROUP(%PrototypeExporterEnd)
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#EXTENSION(GlobalVarProcs,'2000.12.30: DLL Data Set/Get Procedures'),APPLICATION
#!---------------------------------------------------------------------
#PREPARE
#ENDPREPARE
#!---------------------------------------------------------------------
#SHEET
#TAB('General')
  #BOXED('')
    #DISPLAY('Solution created by: Roberto Artigas Jr.')
    #DISPLAY('E-Mail at location: rartiga1@midsouth.rr.com')
    #DISPLAY('Template created by: Roberto Artigas Jr.')
    #DISPLAY('')
    #DISPLAY('This is a part of a multi-dictionary application solution.')
    #DISPLAY('Each dictionary being in it''s own DLL.')
    #DISPLAY('')
    #DISPLAY('This part creates:')
    #DISPLAY('1) A "Get" and "Set" routine for each global variable.')
    #DISPLAY('2) A routine that set''s the GlobalRequest.')
    #DISPLAY('3) A routine that get''s the GlobalResponse.')
    #DISPLAY('4) A routine for each data file to set the file name.')
    #DISPLAY('5) A routine that sets all the file names.')
    #DISPLAY('6) An export file will all the generated routines.')
    #DISPLAY('7) A prototype (STD) file with all the exported routines.')
  #ENDBOXED
#ENDTAB
#TAB('Parameters')
  #BOXED('')
    #PROMPT('Generate Debug Code? ',CHECK),%DebugCode,DEFAULT(0),AT(10)
  #ENDBOXED
  #BOXED('DLL Data Set/Get Procedures')
    #PROMPT('Include Filename:',@S13), %IncludeFilename, REQ, DEFAULT(UPPER(SLICE(%Program, 1, INSTRING('.', %Program, 1, 1)-1)) & '.STD')
    #DISPLAY('')
    #PROMPT('Variables per Module: ',@N7),%VarsInModule,REQ,DEFAULT(20)
    #PROMPT('Files per Module: ',@n7),%FilesInModule,REQ,DEFAULT(20)
    #DISPLAY('')
    #PROMPT('Use GLOBAL path variables? ',CHECK),%gVarGlobal,AT(10,,180)
      #ENABLE(%gVarGlobal)
        #PROMPT('Windows Main Directory: ',FROM(%GlobalData)),%gVarWinIni,DEFAULT('')
        #PROMPT('Windows System Directory: ',FROM(%GlobalData)),%gVarWinSys,DEFAULT('')
        #PROMPT('Windows Temp Directory: ',FROM(%GlobalData)),%gVarWinTmp,DEFAULT('')
        #PROMPT('Data Files Directory: ',FROM(%GlobalData)),%gVarDatFe1,DEFAULT('')
#!        #PROMPT('Data Files Directory 1: ',FROM(%GlobalData)),%gVarDatFe1,DEFAULT('')
#!        #PROMPT('Data Files Directory 2: ',FROM(%GlobalData)),%gVarDatFe2,DEFAULT('')
      #ENDENABLE
    #DISPLAY('')
    #PROMPT('SetRequest/GetResponse GLOBAL Routines? ',CHECK),%SetSelect,AT(10),DEFAULT(1)
  #ENDBOXED
#ENDTAB
#ENDSHEET
#!---------------------------------------------------------------------
#IF(NOT %gVarGlobal)
  #SET(%gVarWinIni,'')
  #SET(%gVarWinSys,'')
  #SET(%gVarWinTmp,'')
  #SET(%gVarDatFe1,'')
  #SET(%gVarDatFe2,'')
#ENDIF
#!---------------------------------------------------------------------
#COMMENT(61)
#!---------------------------------------------------------------------
#! RAS.2000.11.10 - Read all the ABC definitions (You want: %UsedFile)
#! #FOR(%UsedFile)
#! !RTCDOC: Used File = %UsedFile
#! #ENDFOR
#ATSTART
#CALL(%ReadABCFiles(ABC))
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!
#AT(%CustomGlobalDeclarations)
#!
#DECLARE(%GDLLName,   STRING)
#DECLARE(%GDataName,  STRING)
#DECLARE(%GDataType,  STRING)
#DECLARE(%GDataProto, STRING)
#DECLARE(%GDataValue, STRING)
#DECLARE(%GDataRc,    STRING)
#DECLARE(%GDataLink,  STRING)
#DECLARE(%GDataWork1, STRING)
#DECLARE(%GDataWork2, STRING)
#DECLARE(%GPos,LONG)
#!
#DECLARE(%RaFileName, STRING)
#DECLARE(%RaClipName, STRING)
#DECLARE(%RaWorkName, STRING)
#!
#DECLARE(%UserOpt,    STRING)
#DECLARE(%FileOpt,    STRING)
#DECLARE(%WorkOpt,    STRING)
#DECLARE(%DataOpt,    STRING)
#DECLARE(%ReplOpt,    STRING)
#!
#DECLARE(%TheDate,    STRING)
#DECLARE(%TheTime,    STRING)
#SET(%TheDate,FORMAT(TODAY(),@D10))
#SET(%TheTime,FORMAT(CLOCK(),@T06))
#!
#DECLARE(%GDCount,    LONG)
#SET(%GDCount,0)
#DECLARE(%GDLoop,     LONG)
#SET(%GDLoop,1)
#DECLARE(%GDOpen,     LONG)
#SET(%GDOpen,0)
#!
#MESSAGE('DLL DATA Access Module Definitions',1)
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #IF(%GDLoop=1)
    #SET(%GDOpen,1)
    #SET(%GDCount,%GDCount+1)
    #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
    #SET(%RaClipName, %RaClipName & 'G' & FORMAT(%GDCount,@n02))
    #SET(%RaFileName, %RaClipName & '.CLW')
    #SET(%RaWorkName, %RaClipName & '.$$$')
    #PROJECT(%RaFileName)
    #CREATE(%RaWorkName)

  MEMBER('%Application.CLW')
#INSERT(%zFilesUsed)                                    #! TESTING
  #ENDIF
#!
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & %Application & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #END

  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDLLName & %GDataProto)))
!
! Procedure:    fnGet_%GDLLName
! Purpose:      Get '%GlobalData' variable to user
! Author:       Roberto Artigas Jr
! Link Name:    %GDataLink
!
fnGet_%[18]GDLLName PROCEDURE(%GDataValue)
  CODE
  %[22]GDataValue = %GlobalData
  RETURN(TRUE)

  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDLLName & %GDataProto)))
!
! Procedure:    fnSet_%GDLLName
! Purpose:      Set '%GlobalData' variable from user
! Author:       Roberto Artigas Jr
! Link Name:    %GDataLink
!
fnSet_%[18]GDLLName PROCEDURE(%GDataValue)
  CODE
  %[22]GlobalData = %GDataValue
  RETURN(TRUE)

  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%VarsInModule+1))
    #IF(%GDOpen)
      #CLOSE (%RaWorkName)
      #REPLACE (%RaFileName, %RaWorkName)
      #REMOVE (%RaWorkName)
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#IF(%GDOpen)
  #CLOSE (%RaWorkName)
  #REPLACE (%RaFileName, %RaWorkName)
  #REMOVE (%RaWorkName)
  #SET(%GDOpen,0)
#ENDIF
#!
#! Create The File Routines
#! ------------------------
#MESSAGE('File Name Set Definitions',1)
#SET(%GDCount,0)
#SET(%GDLoop,1)
#SET(%GDOpen,0)
#FOR(%File)
  #!
  #CASE(%FileType)
    #OF('VIEW')
  #OROF('ALIAS')
      #CYCLE
  #ENDCASE
  #CASE(%FileDriver)
    #OF('ASCII')
  #OROF('BASIC')
  #OROF('DOS')
    #CYCLE
  #ENDCASE
  #SET(%UserOpt,EXTRACT(%FileUserOptions,'FILENAME'))
  #SET(%FileOpt,EXTRACT(%UserOpt,'FILENAME',1))
  #SET(%WorkOpt,EXTRACT(%UserOpt,'FILENAME',2))
  #SET(%DataOpt,EXTRACT(%UserOpt,'FILENAME',3))
  #SET(%ReplOpt,EXTRACT(%UserOpt,'FILENAME',4))
  #IF(%FileOpt='')
    #CYCLE
  #ENDIF
  #!
  #MESSAGE('Creating: ' & %File ,2)
  #IF(%GDLoop=1)
    #SET(%GDOpen,1)
    #SET(%GDCount,%GDCount+1)
    #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
    #SET(%RaClipName, %RaClipName & 'F' & FORMAT(%GDCount,@n02))
    #SET(%RaFileName, %RaClipName & '.CLW')
    #SET(%RaWorkName, %RaClipName & '.$$$')
    #PROJECT(%RaFileName)
    #CREATE(%RaWorkName)

  MEMBER('%Application.CLW')
  #ENDIF

  #SET(%GDataName,%Application & '_' & %File)
  #SET(%GDataProto,'(LONG,STRING),PROC,BYTE')
  #SET(%GDataValue,'lngWhere,strValue')
  #IF(%WorkOpt='')
    #SET(%WorkOpt,'strValue')
  #ENDIF
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
!
! Procedure:    fnSet_%GDataName
! Purpose:      Set '%File' Name For Programmer
! Author:       Roberto Artigas Jr
! Options:      %UserOpt
! Link Name:    %GDataLink
! Parameter:    lngWhere    : 0 = Set Default Name, 1 = Set Replace Name
!               strValue    : This is the replace name to set
!
fnSet_%[17]GDataName PROCEDURE(%GDataValue)
  CODE
  CASE(lngWhere)
  OF 1                                              #<! Set Replace Name
  #CASE(UPPER(%DataOpt))
  #OF('INI')                                        #! FILENAME(,,INI,)
    #IF(%gVarWinIni)
    %[19]WorkOpt = CLIP(%gVarWinIni) & strValue     #<! Set Directory/Value
    #ELSE
      #IF(%WorkOpt <> 'strValue')
    %[19]WorkOpt = strValue                         #<! Set Value
      #ENDIF
    #ENDIF
  #OF('SYS')                                        #! FILENAME(,,SYS,)
    #IF(%gVarWinSys)
    %[19]WorkOpt = CLIP(%gVarWinSys) & strValue     #<! Set Directory/Value
    #ELSE
      #IF(%WorkOpt <> 'strValue')
    %[19]WorkOpt = strValue                         #<! Set Value
      #ENDIF
    #ENDIF
  #OF('TMP')                                        #! FILENAME(,,TMP,)
    #IF(%gVarWinTmp)
    %[19]WorkOpt = CLIP(%gVarWinTmp) & strValue     #<! Set Directory/Value
    #ELSE
      #IF(%WorkOpt <> 'strValue')
    %[19]WorkOpt = strValue                         #<! Set Value
      #ENDIF
    #ENDIF
  #ELSE                                             #! FILENAME(,,DATA,)
    #IF(%gVarDatFe1)
    %[19]WorkOpt = CLIP(%gVarDatFe1) & strValue     #<! Set Directory/Value
    #ELSE
      #IF(%WorkOpt <> 'strValue')
    %[19]WorkOpt = strValue                         #<! Set Value
      #ENDIF
    #ENDIF
  #ENDCASE
  ELSE                                              #<! Set Default Name
  #CASE(UPPER(%DataOpt))
  #OF('INI')                                        #! FILENAME(,,INI,)
    #IF(%gVarWinIni)
    %[19]WorkOpt = CLIP(%gVarWinIni) & %FileOpt     #<! Set Directory/Value
    #ELSE
    %[19]WorkOpt = %FileOpt                         #<! Set Value
    #ENDIF
  #OF('SYS')                                        #! FILENAME(,,SYS,)
    #IF(%gVarWinSys)
    %[19]WorkOpt = CLIP(%gVarWinSys) & %FileOpt     #<! Set Directory/Value
    #ELSE
    %[19]WorkOpt = %FileOpt                         #<! Set Value
    #ENDIF
  #OF('TMP')                                        #! FILENAME(,,TMP,)
    #IF(%gVarWinTmp)
    %[19]WorkOpt = CLIP(%gVarWinTmp) & %FileOpt     #<! Set Directory/Value
    #ELSE
    %[19]WorkOpt = %FileOpt                         #<! Set Value
    #ENDIF
  #ELSE                                             #! FILENAME(,,DATA,)
    #IF(%gVarDatFe1)
    %[19]WorkOpt = CLIP(%gVarDatFe1) & %FileOpt     #<! Set Directory/Value
    #ELSE
    %[19]WorkOpt = %FileOpt                         #<! Set Value
    #ENDIF
  #ENDCASE
  END
  #IF(UPPER(%ReplOpt)='YES')
    #CASE(UPPER(%FILE))
    #ENDCASE
  #ENDIF
  #!
  #IF(%False)
  STOP('fnSetName_%GDataName=''' & CLIP(%WorkOpt) & '''')
  #ENDIF
  #!
  Access:%File.SetName(%WorkOpt)
  RETURN(TRUE)

  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%FilesInModule+1))
    #IF(%GDOpen)
      #CLOSE (%RaWorkName)
      #REPLACE (%RaFileName, %RaWorkName)
      #REMOVE (%RaWorkName)
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#IF(%GDOpen)
  #CLOSE (%RaWorkName)
  #REPLACE (%RaFileName, %RaWorkName)
  #REMOVE (%RaWorkName)
  #SET(%GDOpen,0)
#ENDIF
#!
#! Create Complete File Name Caller
#! --------------------------------
#COMMENT(61)
#!#SET(%RaClipName, 'FDLL_000')
#SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)) & 'F00')
#SET(%RaFileName, %RaClipName & '.CLW')
#SET(%RaWorkName, %RaClipName & '.$$$')
#MESSAGE('Creating: ' & %RaFileName ,2)
#PROJECT(%RaFileName)
#CREATE(%RaWorkName)
#!#SET(%GDataName,'FDLL_000')
#SET(%GDataName, UPPER(SLICE(%Program, 1, 5)) & 'F00')
#SET(%GDataProto,'()')
#SET(%GDataValue,'')

  MEMBER('%Application.CLW')
#INSERT(%zFilesUsed)                                    #! TESTING

#IF(%SetSelect)
  #SET(%GDataName, %Application & '_Request')
  #SET(%GDataProto,'(LONG),PROC,LONG')
  #SET(%GDataValue,'slValue')
  #SET(%GDataRc,'slRc')
  #SET(%GDataWork1,'GlobalRequest')
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
!
! Procedure:    fnSet_%GDataName
! Purpose:      Set 'GlobalRequest'
! Author:       Roberto Artigas Jr
! Link:         %GDataLink
!
fnSet_%[17]GDataName PROCEDURE(%GDataValue)
%[23]GDataRc LONG(0)                #<! Save OLD setting
  CODE
  %[21]GDataRc = %GDataWork1        #<! Save current value
  %[21]GDataWork1 = %GDataValue     #<! Time for operation
  RETURN(%GDataRc)                  #<! Return OLD setting

  #SET(%GDataName, %Application & '_Response')
  #SET(%GDataProto,'(),LONG')
  #SET(%GDataValue,'')
  #SET(%GDataRc,'')
  #SET(%GDataWork1,'GlobalResponse')
  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDataName & %GDataProto)))
!
! Procedure:    fnGet_%GDataName
! Purpose:      Get 'GlobalResult'
! Author:       Roberto Artigas Jr
! Link:         %GDataLink
!
fnGet_%[17]GDataName PROCEDURE(%GDataValue)
  CODE
  RETURN(%GDataWork1)               #<! Return setting

#ENDIF
#SET(%GDataName, %Application & '_AllNames')
#SET(%GDataProto,'()')
#SET(%GDataValue,'')
#SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
!
! Procedure:    fnSet_%GDataName
! Purpose:      Set File Names For All Files
! Author:       Roberto Artigas Jr
! Link:         %GDataLink
!
fnSet_%[17]GDataName PROCEDURE()
  CODE
#IF(%TRUE)

  #FOR(%File)
    #!
    #CASE(%FileType)
      #OF('VIEW')
    #OROF('ALIAS')
        #CYCLE
    #ENDCASE
    #CASE(%FileDriver)
      #OF('ASCII')
    #OROF('BASIC')
    #OROF('DOS')
      #CYCLE
    #ENDCASE
    #SET(%UserOpt,EXTRACT(%FileUserOptions,'FILENAME'))
    #SET(%FileOpt,EXTRACT(%UserOpt,'FILENAME',1))
    #SET(%WorkOpt,EXTRACT(%UserOpt,'FILENAME',2))
    #SET(%DataOpt,EXTRACT(%UserOpt,'FILENAME',3))
    #SET(%ReplOpt,EXTRACT(%UserOpt,'FILENAME',4))
    #IF(%FileOpt='')
      #CYCLE
    #ENDIF
    #IF(SUB(%File,1,1)='Z')
      #CYCLE
    #END
    #!
    #SET(%GDataName,%Application & '_' & %File)
  fnSet_%GDataName(1, %FileOpt) #<! %UserOpt
  #ENDFOR
#ENDIF

  RETURN

#CLOSE(%RaWorkName)
#REPLACE(%RaFileName, %RaWorkName)
#REMOVE(%RaWorkName)
#COMMENT(61)
#!
#! Build include File
#! ------------------
  #MESSAGE('Prototypes for standard (STD) include file',1)
  #CREATE(%BuildInclude)
!BOF
!
! File:         %IncludeFileName
! Purpose:      Include Of DLL Procedures
! Author:       Roberto Artigas Jr
!
  #!#SET(%GDataName,'FDLL_000')
  #SET(%GDataName, UPPER(SLICE(%Program, 1, 5)))
  #SET(%GDataName, %GDataName & 'F00')
  #SET(%GDataProto,'(),DLL')    #! What???
  #SET(%GDataProto,',DLL')      #! Just being neat!
  #SET(%GDataValue,'')
#! ----------------------------------------- !
#! This section does unique routines per dll !
#! ----------------------------------------- !
#IF(%SetSelect)
  #SET(%GDataName, %Application & '_Request')
  #SET(%GDataProto,'(LONG),PROC,LONG,DLL')
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnSet_' & %GDataName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Set GlobalRequest')
%OOPConstruct
  #SET(%GDataName, %Application & '_Response')
  #SET(%GDataProto,',LONG,DLL')
  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDataName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnGet_' & %GDataName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Get GlobalResponse')
%OOPConstruct
#ENDIF
  #SET(%GDataName, %Application & '_AllNames')
  #SET(%GDataProto,',DLL')
  #SET(%GDataValue,'')
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnSet_' & %GDataName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Set All File Names')
%OOPConstruct
#! --------------------------------------------- !
#! This section does set file name for all files !
#! --------------------------------------------- !
#FOR(%File)
  #!
  #CASE(%FileType)
    #OF('VIEW')
  #OROF('ALIAS')
      #CYCLE
  #ENDCASE
  #CASE(%FileDriver)
    #OF('ASCII')
  #OROF('BASIC')
  #OROF('DOS')
    #CYCLE
  #ENDCASE
  #SET(%UserOpt,EXTRACT(%FileUserOptions,'FILENAME'))
  #SET(%FileOpt,EXTRACT(%UserOpt,'FILENAME',1))
  #SET(%WorkOpt,EXTRACT(%UserOpt,'FILENAME',2))
  #SET(%DataOpt,EXTRACT(%UserOpt,'FILENAME',3))
  #SET(%ReplOpt,EXTRACT(%UserOpt,'FILENAME',4))
  #IF(%FileOpt='')
    #CYCLE
  #ENDIF
  #!
  #MESSAGE('Creating: ' & %File ,2)
  #SET(%GDataName,%Application & '_' & %File)
  #SET(%GDataProto,'(LONG,STRING),PROC,BYTE,DLL')
  #SET(%GDataValue,'lngWhere,strValue')
  #IF(%WorkOpt='')
    #SET(%WorkOpt,'strValue')
  #ENDIF
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnSet_' & %GDataName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Set file name for ' & %File)
%OOPConstruct
#ENDFOR
#! ------------------------------------------- !
#! This section does global get/set procedures !
#! ------------------------------------------- !
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & %Application & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE,DLL')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE,DLL')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE,DLL')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE,DLL')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE,DLL')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE,DLL')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE,DLL')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE,DLL')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE,DLL')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE,DLL')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE,DLL')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE,DLL')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE,DLL')
    #SET(%GDataValue,'strValue')
  #END
  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDLLName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnGet_' & %GDLLName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Get global ' & %GlobalData)
%OOPConstruct
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDLLName & %GDataProto)))
  #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, 'fnSet_' & %GDLLName, 'PROCEDURE' & %GDataProto)
  #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct, %OOPConstruct, '! Set global ' & %GlobalData)
%OOPConstruct
#ENDFOR
#! --------------------------------------------------- !
#! This section does the normal application prototypes !
#! --------------------------------------------------- !
  #FOR(%Procedure),WHERE(%ProcedureExported)
    #MESSAGE('Creating:' & %Procedure ,2)
    #!INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, %Procedure, %ProcedureType & %Prototype)
    #INSERT(%MakeDeclr(ABC), 26, %OOPConstruct, %Procedure, %ProcedureType & %Prototype & ',DLL')
    #IF(%ProcedureDescription)
      #INSERT(%MakeDeclr(ABC), 63, %OOPConstruct,  %OOPConstruct, '! ' & %ProcedureDescription)
    #ENDIF
%OOPConstruct
  #ENDFOR
!
!EOF
  #CLOSE(%BuildInclude)
  #REPLACE(%IncludeFilename, %BuildInclude)
  #REMOVE(%BuildInclude)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%AfterGlobalIncludes)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#MESSAGE('MAP Module Definitions',1)
#AT(%GlobalMap)
  #SET(%GDCount,0)
  #SET(%GDLoop,1)
  #SET(%GDOpen,0)
  #FOR(%GlobalData)
    #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
      #CYCLE
    #ENDIF
    #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
      #CYCLE
    #ENDIF
#!
    #MESSAGE('Creating: ' & %GlobalData ,2)
    #IF(%GDLoop=1)
      #SET(%GDOpen,1)
      #SET(%GDCount,%GDCount+1)
      #!#SET(%RaClipName, 'GDLL_'&FORMAT(%GDCount,@n03))
      #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
      #SET(%RaClipName, %RaClipName & 'G' & FORMAT(%GDCount,@n02))
      #SET(%RaFileName, %RaClipName & '.CLW')
MODULE('%RaFileName')
    #ENDIF
#!
    #SET(%GDataName,%GlobalData)
    #SET(%GPos,INSTRING(':',%GDataName,1,1))
    #IF(%GPos)
      #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
    #ENDIF
    #!#SET(%GDLLName,('DLL_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
    #SET(%GDLLName,('' & %Application & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
    #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
      #SET(%GDataValue,'cstrValue')
    #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*STRING),PROC,BYTE')
      #SET(%GDataValue,'strValue')
    #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*USHORT),PROC,BYTE')
      #SET(%GDataValue,'ushtValue')
    #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*SHORT),PROC,BYTE')
      #SET(%GDataValue,'sshtValue')
    #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*ULONG),PROC,BYTE')
      #SET(%GDataValue,'ulngValue')
    #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*LONG),PROC,BYTE')
      #SET(%GDataValue,'slngValue')
    #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*REAL),PROC,BYTE')
      #SET(%GDataValue,'realValue')
    #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*BYTE),PROC,BYTE')
      #SET(%GDataValue,'byteValue')
    #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
      #SET(%GDataValue,'uValue')
    #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
      #SET(%GDataValue,'sValue')
    #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*DATE),PROC,BYTE')
      #SET(%GDataValue,'dateValue')
    #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
      #SET(%GDataProto,'(*TIME),PROC,BYTE')
      #SET(%GDataValue,'timeValue')
    #ELSE
      #SET(%GDataProto,'(*STRING),PROC,BYTE')
      #SET(%GDataValue,'strValue')
    #END
#!
    #INDENT(-5)
fnGet_%[18]GDLLName PROCEDURE%GDataProto
fnSet_%[18]GDLLName PROCEDURE%GDataProto
    #INDENT(5)
#!
  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%VarsInModule+1))
    #IF(%GDOpen)
END
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#IF(%GDOpen)
END
  #SET(%GDOpen,0)
#ENDIF
#!
  #!#SET(%GDataName,'FDLL_000.CLW')
  #SET(%GDataName, UPPER(SLICE(%Program, 1, 5)))
  #SET(%GDataName, %GDataName & 'F00')
  #SET(%GDataProto,'(),DLL')        #! What????
  #SET(%GDataProto,'()')            #! RAS.2000.04.14 - In this module
  #SET(%GDataValue,'')
MODULE('%GDataName')
  #INDENT(-5)
  #IF(%SetSelect)
    #SET(%GDataName, %Application & '_Request')
    #SET(%GDataProto,'(LONG),PROC,LONG')
    #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
fnSet_%[18]GDataName PROCEDURE%GDataProto
    #SET(%GDataName, %Application & '_Response')
    #SET(%GDataProto,'(),LONG')
    #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDataName & %GDataProto)))
fnGet_%[18]GDataName PROCEDURE%GDataProto
  #ENDIF
  #SET(%GDataName, %Application & '_AllNames')
  #SET(%GDataProto,'()')
  #SET(%GDataValue,'')
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
fnSet_%[18]GDataName PROCEDURE%GDataProto
  #INDENT(5)
END
#!
  #SET(%GDCount,0)
  #SET(%GDLoop,1)
  #SET(%GDOpen,0)
  #FOR(%File)
    #!
    #CASE(%FileType)
      #OF('VIEW')
    #OROF('ALIAS')
        #CYCLE
    #ENDCASE
    #CASE(%FileDriver)
      #OF('ASCII')
    #OROF('BASIC')
    #OROF('DOS')
      #CYCLE
    #ENDCASE
    #SET(%UserOpt,EXTRACT(%FileUserOptions,'FILENAME'))
    #SET(%FileOpt,EXTRACT(%UserOpt,'FILENAME',1))
    #SET(%WorkOpt,EXTRACT(%UserOpt,'FILENAME',2))
    #SET(%DataOpt,EXTRACT(%UserOpt,'FILENAME',3))
    #SET(%ReplOpt,EXTRACT(%UserOpt,'FILENAME',4))
    #IF(%FileOpt='')
      #CYCLE
    #ENDIF
    #!
    #MESSAGE('Creating: ' & %UserOpt ,2)
    #IF(%GDLoop=1)
      #SET(%GDOpen,1)
      #SET(%GDCount,%GDCount+1)
      #!#SET(%RaClipName, 'FDLL_'&FORMAT(%GDCount,@n03))
      #SET(%RaClipName, UPPER(SLICE(%Program, 1, 5)))
      #SET(%RaClipName, %RaClipName & 'F' & FORMAT(%GDCount,@n02))
      #SET(%RaFileName, %RaClipName & '.CLW')
MODULE('%RaFileName')
    #ENDIF
    #SET(%GDataName,%Application & '_' & %File)
    #SET(%GDataProto,'(LONG,STRING),PROC,BYTE')
    #SET(%GDataValue,'lngWhere,strValue')
    #SET(%GDataLink,UPPER(LINKNAME('fnSetName_' & %GDataName & %GDataProto)))
#!
    #INDENT(-5)
fnSet_%[18]GDataName PROCEDURE%GDataProto
    #INDENT(5)
#!
  #SET(%GDLoop,%GDLoop+1)
  #IF(%GDLoop=(%FilesInModule+1))
    #IF(%GDOpen)
END
      #SET(%GDOpen,0)
    #ENDIF
    #SET(%GDLoop,1)
  #ENDIF
#ENDFOR
#IF(%GDOpen)
END
  #SET(%GDOpen,0)
#ENDIF
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%BeginningExports)
#INDENT(-2)
; Special Multiple DLL Routines Exports Begin
#INDENT(+2)
#! ----------------------------------------- !
#! This section does unique routines per dll !
#! ----------------------------------------- !
#IF(%SetSelect)
  #SET(%GDataName, %Application & '_Request')
  #SET(%GDataProto,'(LONG),PROC,LONG')
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
%[55]GDataLink @?
  #SET(%GDataName, %Application & '_Response')
  #SET(%GDataProto,'(),LONG')
  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDataName & %GDataProto)))
%[55]GDataLink @?
#ENDIF
#SET(%GDataName, %Application & '_AllNames')
#SET(%GDataProto,'(),DLL')  #! What???
#SET(%GDataProto,'()')      #! Is IN this DLL
#SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
%[55]GDataLink @?
#! --------------------------------------------- !
#! This section does set file name for all files !
#! --------------------------------------------- !
#FOR(%File)
  #!
  #CASE(%FileType)
    #OF('VIEW')
  #OROF('ALIAS')
      #CYCLE
  #ENDCASE
  #CASE(%FileDriver)
    #OF('ASCII')
  #OROF('BASIC')
  #OROF('DOS')
    #CYCLE
  #ENDCASE
  #SET(%UserOpt,EXTRACT(%FileUserOptions,'FILENAME'))
  #SET(%FileOpt,EXTRACT(%UserOpt,'FILENAME',1))
  #SET(%WorkOpt,EXTRACT(%UserOpt,'FILENAME',2))
  #SET(%DataOpt,EXTRACT(%UserOpt,'FILENAME',3))
  #SET(%ReplOpt,EXTRACT(%UserOpt,'FILENAME',4))
  #IF(%FileOpt='')
    #CYCLE
  #ENDIF
  #!
  #MESSAGE('Creating: ' & %File ,2)
  #SET(%GDataName,%Application & '_' & %File)
  #SET(%GDataProto,'(LONG,STRING),PROC,BYTE')
  #SET(%GDataValue,'lngWhere,strValue')
  #IF(%WorkOpt='')
    #SET(%WorkOpt,'strValue')
  #ENDIF
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDataName & %GDataProto)))
%[55]GDataLink @?
#ENDFOR
#! ------------------------------------------- !
#! This section does global get/set procedures !
#! ------------------------------------------- !
#MESSAGE('DLL data access export Definitions',1)
#FOR(%GlobalData)
  #IF(INSTRING('GROUP',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
  #IF(INSTRING('END',%GlobalDataStatement,1,1)>0)
    #CYCLE
  #ENDIF
#!
  #MESSAGE('Creating: ' & %GlobalData , 2)
  #SET(%GDataName,%GlobalData)
  #SET(%GPos,INSTRING(':',%GDataName,1,1))
  #IF(%GPos)
    #SET(%GDataName,(SUB(%GDataName,1,(%GPos-1)) & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
  #ENDIF
  #SET(%GDLLName,('' & %Application & '_' & SUB(%GDataName,(%GPos+1),LEN(%GDataName))))
#!
  #IF(INSTRING('CSTRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*CSTRING),PROC,BYTE')
    #SET(%GDataValue,'cstrValue')
  #ELSIF(INSTRING('STRING',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #ELSIF(INSTRING('USHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*USHORT),PROC,BYTE')
    #SET(%GDataValue,'ushtValue')
  #ELSIF(INSTRING('SHORT',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SHORT),PROC,BYTE')
    #SET(%GDataValue,'sshtValue')
  #ELSIF(INSTRING('ULONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*ULONG),PROC,BYTE')
    #SET(%GDataValue,'ulngValue')
  #ELSIF(INSTRING('LONG',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*LONG),PROC,BYTE')
    #SET(%GDataValue,'slngValue')
  #ELSIF(INSTRING('REAL',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*REAL),PROC,BYTE')
    #SET(%GDataValue,'realValue')
  #ELSIF(INSTRING('BYTE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*BYTE),PROC,BYTE')
    #SET(%GDataValue,'byteValue')
  #ELSIF(INSTRING('UNSIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*UNSIGNED),PROC,BYTE')
    #SET(%GDataValue,'uValue')
  #ELSIF(INSTRING('SIGNED',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*SIGNED),PROC,BYTE')
    #SET(%GDataValue,'sValue')
  #ELSIF(INSTRING('DATE',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*DATE),PROC,BYTE')
    #SET(%GDataValue,'dateValue')
  #ELSIF(INSTRING('TIME',%GlobalDataStatement,1,1)>0)
    #SET(%GDataProto,'(*TIME),PROC,BYTE')
    #SET(%GDataValue,'timeValue')
  #ELSE
    #SET(%GDataProto,'(*STRING),PROC,BYTE')
    #SET(%GDataValue,'strValue')
  #END
  #SET(%GDataLink,UPPER(LINKNAME('fnGet_' & %GDLLName & %GDataProto)))
%[55]GDataLink @?
  #SET(%GDataLink,UPPER(LINKNAME('fnSet_' & %GDLLName & %GDataProto)))
%[55]GDataLink @?
#ENDFOR
#INDENT(-2)
; Special Multiple DLL Routines Exports Ended
#INDENT(+2)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%ProgramSetup),LAST
!BOE: --------------------
  #IF(%DebugCode)
STOP('DLL CONSTRUCTOR BEGIN: ' & UPPER('%Application')) #<! %DebugCode
  #ENDIF
  #SET(%GDataName, %Application & '_AllNames')
fnSet_%GDataName() #<! Set up all the file names
  #IF(%DebugCode)
STOP('DLL CONSTRUCTOR END: ' & UPPER('%Application')) #<! %DebugCode
  #ENDIF
!EOE: --------------------
#INSERT(%zFilesUsed)                                    #! TESTING
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#AT(%GlobalData)
#ENDAT
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#GROUP(%zFilesUsed)
#IF(%FALSE)
!RAS-BOE
  #FOR(%File)
!RAS: Dict File = %File
  #ENDFOR
  #FOR(%UsedFile)
!RAS: Used File = %UsedFile
  #ENDFOR
  #FOR(%UsedFile)
    #FIX(%File,%UsedFile)
!RAS %UsedFile='%File' Prefix='%FilePrefix'
  #ENDFOR
!RAS-EOE
#ENDIF
#!---------------------------------------------------------------------
#GROUP(%GlobalVarProcsEnd)
#!---------------------------------------------------------------------

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------

